#ifndef TARANIS_NODE_HPP_
#define TARANIS_NODE_HPP_

#include "rclcpp/rclcpp.hpp"
#include "taranis/msg/taranis_packet.hpp"

#include <asm/termbits.h>
#include <fcntl.h> 
#include <sys/ioctl.h>
#include <sys/types.h>
#include <unistd.h>
#include <stdio.h>

namespace taranis {

class TaranisNode : public rclcpp::Node {
    public:
        TaranisNode();

    private:    
        int serial_fd_;
        termios2 termios2_;

        bool initialize_serial_();

        rclcpp::Publisher<taranis::msg::TaranisPacket>::SharedPtr publisher_;
        rclcpp::TimerBase::SharedPtr timer_;

        void timer_callback_();
        void publish_packet_();

        int empty_read_ = 0;
        uint8_t buffer_index_ = 0;

        uint8_t buffer_[25];

        double normalize_channel_(uint16_t);
        uint8_t decode_switch_(uint16_t);
};


} // namespace

#endif // TARANIS_NODE_HPP_